/**
 *
 * @file coreblas_c.c
 *
 *  PLASMA core_blas tracing kernel
 *  PLASMA is a software package provided by Univ. of Tennessee,
 *  Univ. of California Berkeley and Univ. of Colorado Denver
 *
 *  This file provides the wrapper for each function of the
 *  core_blas library which will generate an event before and
 *  after the execution of the kernel.
 *  This file is automatically generated with convert2eztrace.pl
 *  script. DO NOT MANUALLY EDIT THIS FILE.
 *
 * @version 2.8.0
 * @author Mathieu Faverge
 * @date 2010-11-15
 * @generated c Fri Apr  1 11:03:14 2016
 *
 **/
#include <eztrace.h>
#include <ev_codes.h>
#include "common.h"
#include "coreblas_ev_codes.h"
#include "coreblas_macros.h"
#undef REAL
#define COMPLEX
#ifdef REAL
#endif
#ifdef REAL
FUNCTION_VOID( CORE_slaed2_compressq, LAED2_COMPRESSQ, void ,
          (int n, int n1, const int *INDX, const int *ctot, const float *Q, int LDQ, float *Q2, int start, int end),
          (n, n1, INDX, ctot, Q, LDQ, Q2, start, end) )
FUNCTION_VOID( CORE_slaed2_copydef, LAED2_COPYDEF, void ,
          (int n, int n1, int K, const int *ctot, float *Q, int LDQ, const float *Q2, int start, int end ),
          (n, n1, K, ctot, Q, LDQ, Q2, start, end) )
#endif
#ifdef REAL
FUNCTION_VOID( CORE_slaed2_computeK, LAED2_COMPUTEK, void ,
          (int *Kptr, int n, int n1, float *betaptr, float *D, float *Q, int LDQ, float *Z, float *DLAMBDA, float *W, int *INDX, int *INDXC, int *INDXP, int *INDXQ, int *COLTYP),
          (Kptr, n, n1, betaptr, D, Q, LDQ, Z, DLAMBDA, W, INDX, INDXC, INDXP, INDXQ, COLTYP) )
#endif
#ifdef REAL
FUNCTION_VOID( CORE_slaed3_computevectors, LAED3_COMPVEC, void ,
          (int K, int il_nondef, int iu_nondef, float *Q, int LDQ, float *W, float *S, const int *INDXC, int start, int end),
          (K, il_nondef, iu_nondef, Q, LDQ, W, S, INDXC, start, end) )
#endif
#ifdef REAL
FUNCTION_VOID( CORE_slaed3_computeW, LAED3_COMPW, void ,
          (int n, int K, const float *Q, int LDQ, const float *DLAMBDA, float *W, const int *INDX, int start, int end),
          (n, K, Q, LDQ, DLAMBDA, W, INDX, start, end) )
#endif
#ifdef REAL
#endif
#ifdef REAL
FUNCTION_VOID( CORE_slaed3_reduceW, LAED3_REDUCEW, void ,
          (int n, int n1, int K, int l, const float *Q, int LDQ, const float *Wred, float *W),
          (n, n1, K, l, Q, LDQ, Wred, W) )
#endif
#ifdef REAL
FUNCTION_VOID( CORE_slaed3_updatevectors, LAED3_UPDATEVECTORS, void ,
          ( int op, int wsmode, int n, int n1, int K, int il_nondef, int iu_nondef, float *Q, int ldq, float *Q2, const int *ctot, float *W, int start, int end),
          (op, wsmode, n, n1, K, il_nondef, iu_nondef, Q, ldq, Q2, ctot, W, start, end) )
#endif
#ifdef REAL
FUNCTION_TYPE( CORE_slaed4, LAED4, int ,
          (int n, int K, float *D, float beta, float *Q, int LDQ, const float *D0, const float *Z, const int *INDX, int start, int end ),
          (n, K, D, beta, Q, LDQ, D0, Z, INDX, start, end) )
#endif
#ifdef COMPLEX
FUNCTION_TYPE( CORE_slag2c, LAG2Z, int ,
          ( int m, int n, const float *R, int ldr, PLASMA_Complex32_t *Z, int ldz ),
          (m, n, R, ldr, Z, ldz) )
#endif
#ifdef REAL
#endif
FUNCTION_VOID( CORE_scasum, ASUM, void ,
          (PLASMA_enum storev, PLASMA_enum uplo, int M, int N, const PLASMA_Complex32_t *A, int lda, float *work),
          (storev, uplo, M, N, A, lda, work) )
FUNCTION_VOID( CORE_cbrdalg1, BRDALG, void ,
          ( PLASMA_enum uplo, int n, int nb, PLASMA_Complex32_t *A, int lda, PLASMA_Complex32_t *VQ, PLASMA_Complex32_t *TAUQ, PLASMA_Complex32_t *VP, PLASMA_Complex32_t *TAUP, int Vblksiz, int wantz, int i, int sweepid, int m, int grsiz, PLASMA_Complex32_t *work),
          (uplo, n, nb, A, lda, VQ, TAUQ, VP, TAUP, Vblksiz, wantz, i, sweepid, m, grsiz, work) )
FUNCTION_VOID( CORE_cgbtype1cb, TYPE1, void ,
          (PLASMA_enum uplo, int N, int NB, PLASMA_Complex32_t *A, int LDA, PLASMA_Complex32_t *VQ, PLASMA_Complex32_t *TAUQ, PLASMA_Complex32_t *VP, PLASMA_Complex32_t *TAUP, int st, int ed, int sweep, int Vblksiz, int WANTZ, PLASMA_Complex32_t *WORK),
          (uplo, N, NB, A, LDA, VQ, TAUQ, VP, TAUP, st, ed, sweep, Vblksiz, WANTZ, WORK) )
FUNCTION_VOID( CORE_cgbtype2cb, TYPE2, void ,
          (PLASMA_enum uplo, int N, int NB, PLASMA_Complex32_t *A, int LDA, PLASMA_Complex32_t *VQ, PLASMA_Complex32_t *TAUQ, PLASMA_Complex32_t *VP, PLASMA_Complex32_t *TAUP, int st, int ed, int sweep, int Vblksiz, int WANTZ, PLASMA_Complex32_t *WORK),
          (uplo, N, NB, A, LDA, VQ, TAUQ, VP, TAUP, st, ed, sweep, Vblksiz, WANTZ, WORK) )
FUNCTION_VOID( CORE_cgbtype3cb, TYPE3, void ,
          (PLASMA_enum uplo, int N, int NB, PLASMA_Complex32_t *A, int LDA, PLASMA_Complex32_t *VQ, PLASMA_Complex32_t *TAUQ, PLASMA_Complex32_t *VP, PLASMA_Complex32_t *TAUP, int st, int ed, int sweep, int Vblksiz, int WANTZ, PLASMA_Complex32_t *WORK),
          (uplo, N, NB, A, LDA, VQ, TAUQ, VP, TAUP, st, ed, sweep, Vblksiz, WANTZ, WORK) )
FUNCTION_TYPE( CORE_cgeadd, GEADD, int ,
          (PLASMA_enum trans, int M, int N, PLASMA_Complex32_t alpha, const PLASMA_Complex32_t *A, int LDA, PLASMA_Complex32_t beta, PLASMA_Complex32_t *B, int LDB),
          (trans, M, N, alpha, A, LDA, beta, B, LDB) )
FUNCTION_TYPE( CORE_cgelqt, GELQT, int ,
          (int M, int N, int IB, PLASMA_Complex32_t *A, int LDA, PLASMA_Complex32_t *T, int LDT, PLASMA_Complex32_t *TAU, PLASMA_Complex32_t *WORK),
          (M, N, IB, A, LDA, T, LDT, TAU, WORK) )
FUNCTION_VOID( CORE_cgemm, GEMM, void ,
          (PLASMA_enum transA, int transB, int M, int N, int K, PLASMA_Complex32_t alpha, const PLASMA_Complex32_t *A, int LDA, const PLASMA_Complex32_t *B, int LDB, PLASMA_Complex32_t beta, PLASMA_Complex32_t *C, int LDC),
          (transA, transB, M, N, K, alpha, A, LDA, B, LDB, beta, C, LDC) )
FUNCTION_VOID( CORE_cgemv, GEMV, void ,
          (PLASMA_enum trans, int m, int n, PLASMA_Complex32_t alpha, const PLASMA_Complex32_t *A, int lda, const PLASMA_Complex32_t *x, int incx, PLASMA_Complex32_t beta, PLASMA_Complex32_t *y, int incy),
          (trans, m, n, alpha, A, lda, x, incx, beta, y, incy) )
FUNCTION_VOID( CORE_cgeqp3_init, GEQP3_INIT, void ,
          ( int n, int *jpvt ),
          (n, jpvt) )
FUNCTION_VOID( CORE_cgeqp3_larfg, LARFG, void ,
          ( PLASMA_desc A, int ii, int jj, int i, int j, PLASMA_Complex32_t *tau, PLASMA_Complex32_t *beta ),
          (A, ii, jj, i, j, tau, beta) )
FUNCTION_VOID( CORE_cgeqp3_norms, GEQP3_NORMS, void ,
          ( PLASMA_desc A, int ioff, int joff, float *norms1, float *norms2 ),
          (A, ioff, joff, norms1, norms2) )
FUNCTION_VOID( CORE_cgeqp3_pivot, GEQP3_PIVOT, void ,
          ( PLASMA_desc A, PLASMA_Complex32_t *F, int ldf, int jj, int k, int *jpvt, float *norms1, float *norms2, int *info ),
          (A, F, ldf, jj, k, jpvt, norms1, norms2, info) )
FUNCTION_TYPE( CORE_cgeqp3_tntpiv, GEQRT, int ,
          (int m, int n, PLASMA_Complex32_t *A, int lda, int *IPIV, PLASMA_Complex32_t *tau, int *iwork),
          (m, n, A, lda, IPIV, tau, iwork) )
FUNCTION_VOID( CORE_cgeqp3_update, GEQP3_UPDATE, void ,
          ( const PLASMA_Complex32_t *Ajj, int lda1, PLASMA_Complex32_t *Ajk, int lda2, const PLASMA_Complex32_t *Fk, int ldf, int joff, int k, int koff, int nb, float *norms1, float *norms2, int *info ),
          (Ajj, lda1, Ajk, lda2, Fk, ldf, joff, k, koff, nb, norms1, norms2, info) )
FUNCTION_TYPE( CORE_cgeqrt, GEQRT, int ,
          (int M, int N, int IB, PLASMA_Complex32_t *A, int LDA, PLASMA_Complex32_t *T, int LDT, PLASMA_Complex32_t *TAU, PLASMA_Complex32_t *WORK),
          (M, N, IB, A, LDA, T, LDT, TAU, WORK) )
FUNCTION_TYPE( CORE_cgessm, GESSM, int ,
          (int M, int N, int K, int IB, const int *IPIV, const PLASMA_Complex32_t *L, int LDL, PLASMA_Complex32_t *A, int LDA),
          (M, N, K, IB, IPIV, L, LDL, A, LDA) )
FUNCTION_TYPE( CORE_cgessq, LASSQ, int ,
          (int M, int N, const PLASMA_Complex32_t *A, int LDA, float *scale, float *sumsq),
          (M, N, A, LDA, scale, sumsq) )
FUNCTION_TYPE( CORE_cgetrf, GETRF, int ,
          (int m, int n, PLASMA_Complex32_t *A, int lda, int *IPIV, int *info),
          (m, n, A, lda, IPIV, info) )
FUNCTION_TYPE( CORE_cgetrf_incpiv, GETRF, int ,
          (int M, int N, int IB, PLASMA_Complex32_t *A, int LDA, int *IPIV, int *INFO),
          (M, N, IB, A, LDA, IPIV, INFO) )
FUNCTION_TYPE( CORE_cgetrf_nopiv, GETRF, int ,
          (int M, int N, int IB, PLASMA_Complex32_t *A, int LDA),
          (M, N, IB, A, LDA) )
FUNCTION_TYPE( CORE_cgetrf_reclap, GETRF, int,
          (CORE_cgetrf_data_t *data, int M, int N, PLASMA_Complex32_t *A, int LDA, int *IPIV, int *info),
          (data, M, N, A, LDA, IPIV, info) )
FUNCTION_TYPE( CORE_cgetrf_rectil, GETRF, int,
          (CORE_cgetrf_data_t *data, const PLASMA_desc A, int *IPIV, int *info),
          (data, A, IPIV, info) )
FUNCTION_VOID( CORE_cgetrip, GETRIP, void ,
          (int m, int n, PLASMA_Complex32_t *A, PLASMA_Complex32_t *W) ,
          (m, n, A, W)  )
FUNCTION_VOID( CORE_chbtype1cb, TYPE1, void ,
          (int N, int NB, PLASMA_Complex32_t *A, int LDA, PLASMA_Complex32_t *V, PLASMA_Complex32_t *TAU, int st, int ed, int sweep, int Vblksiz, int WANTZ, PLASMA_Complex32_t *WORK),
          (N, NB, A, LDA, V, TAU, st, ed, sweep, Vblksiz, WANTZ, WORK) )
FUNCTION_VOID( CORE_chbtype2cb, TYPE2, void ,
          (int N, int NB, PLASMA_Complex32_t *A, int LDA, PLASMA_Complex32_t *V, PLASMA_Complex32_t *TAU, int st, int ed, int sweep, int Vblksiz, int WANTZ, PLASMA_Complex32_t *WORK),
          (N, NB, A, LDA, V, TAU, st, ed, sweep, Vblksiz, WANTZ, WORK) )
FUNCTION_VOID( CORE_chbtype3cb, TYPE3, void ,
          (int N, int NB, PLASMA_Complex32_t *A, int LDA, const PLASMA_Complex32_t *V, const PLASMA_Complex32_t *TAU, int st, int ed, int sweep, int Vblksiz, int WANTZ, PLASMA_Complex32_t *WORK),
          (N, NB, A, LDA, V, TAU, st, ed, sweep, Vblksiz, WANTZ, WORK) )
FUNCTION_VOID( CORE_chegst, HEGST, void ,
          (int itype, PLASMA_enum uplo, int N, PLASMA_Complex32_t *A, int LDA, PLASMA_Complex32_t *B, int LDB, int *INFO),
          (itype, uplo, N, A, LDA, B, LDB, INFO) )
#ifdef COMPLEX
FUNCTION_VOID( CORE_chemm, HEMM, void ,
          (PLASMA_enum side, PLASMA_enum uplo, int M, int N, PLASMA_Complex32_t alpha, const PLASMA_Complex32_t *A, int LDA, const PLASMA_Complex32_t *B, int LDB, PLASMA_Complex32_t beta, PLASMA_Complex32_t *C, int LDC),
          (side, uplo, M, N, alpha, A, LDA, B, LDB, beta, C, LDC) )
#endif
#ifdef COMPLEX
FUNCTION_VOID( CORE_cher2k, HER2K, void ,
          (PLASMA_enum uplo, PLASMA_enum trans, int N, int K, PLASMA_Complex32_t alpha, const PLASMA_Complex32_t *A, int LDA, const PLASMA_Complex32_t *B, int LDB, float beta, PLASMA_Complex32_t *C, int LDC),
          (uplo, trans, N, K, alpha, A, LDA, B, LDB, beta, C, LDC) )
#endif
FUNCTION_TYPE( CORE_cherfb, HERFB, int ,
          ( PLASMA_enum uplo, int n, int k, int ib, int nb, const PLASMA_Complex32_t *A, int lda, const PLASMA_Complex32_t *T, int ldt, PLASMA_Complex32_t *C, int ldc, PLASMA_Complex32_t *WORK, int ldwork ),
          (uplo, n, k, ib, nb, A, lda, T, ldt, C, ldc, WORK, ldwork) )
#ifdef COMPLEX
FUNCTION_VOID( CORE_cherk, HERK, void ,
          (PLASMA_enum uplo, PLASMA_enum trans, int N, int K, float alpha, const PLASMA_Complex32_t *A, int LDA, float beta, PLASMA_Complex32_t *C, int LDC),
          (uplo, trans, N, K, alpha, A, LDA, beta, C, LDC) )
#endif
#ifdef COMPLEX
FUNCTION_TYPE( CORE_chessq, LASSQ, int ,
          (PLASMA_enum uplo, int N, const PLASMA_Complex32_t *A, int LDA, float *scale, float *sumsq),
          (uplo, N, A, LDA, scale, sumsq) )
#endif
FUNCTION_VOID( CORE_clacpy, LACPY, void ,
          (PLASMA_enum uplo, int M, int N, const PLASMA_Complex32_t *A, int LDA, PLASMA_Complex32_t *B, int LDB),
          (uplo, M, N, A, LDA, B, LDB) )
FUNCTION_TYPE( CORE_clacpy_pivot, LACPY, int ,
          ( const PLASMA_desc descA, PLASMA_enum direct, int k1, int k2, const int *ipiv, int *rankin, int *rankout, PLASMA_Complex32_t *A, int lda, int init),
          (descA, direct, k1, k2, ipiv, rankin, rankout, A, lda, init) )
FUNCTION_VOID( CORE_clange, LANGE, void ,
          (int norm, int M, int N, const PLASMA_Complex32_t *A, int LDA, float *work, float *normA),
          (norm, M, N, A, LDA, work, normA) )
#ifdef COMPLEX
FUNCTION_VOID( CORE_clanhe, LANHE, void ,
          (int norm, PLASMA_enum uplo, int N, const PLASMA_Complex32_t *A, int LDA, float *work, float *normA),
          (norm, uplo, N, A, LDA, work, normA) )
#endif
FUNCTION_VOID( CORE_clansy, LANSY, void ,
          (int norm, PLASMA_enum uplo, int N, const PLASMA_Complex32_t *A, int LDA, float *work, float *normA),
          (norm, uplo, N, A, LDA, work, normA) )
FUNCTION_VOID( CORE_clantr, LANGE, void ,
          (PLASMA_enum norm, PLASMA_enum uplo, PLASMA_enum diag, int M, int N, const PLASMA_Complex32_t *A, int LDA, float *work, float *normA),
          (norm, uplo, diag, M, N, A, LDA, work, normA) )
FUNCTION_TYPE( CORE_clarfb_gemm, LARFB, int ,
          (PLASMA_enum side, PLASMA_enum trans, int direct, int storev, int M, int N, int K, const PLASMA_Complex32_t *V, int LDV, const PLASMA_Complex32_t *T, int LDT, PLASMA_Complex32_t *C, int LDC, PLASMA_Complex32_t *WORK, int LDWORK),
          (side, trans, direct, storev, M, N, K, V, LDV, T, LDT, C, LDC, WORK, LDWORK) )
FUNCTION_VOID( CORE_claset2, LASET, void ,
          (PLASMA_enum uplo, int M, int N, PLASMA_Complex32_t alpha, PLASMA_Complex32_t *A, int LDA),
          (uplo, M, N, alpha, A, LDA) )
FUNCTION_VOID( CORE_claset, LASET, void ,
          (PLASMA_enum uplo, int M, int N, PLASMA_Complex32_t alpha, PLASMA_Complex32_t beta, PLASMA_Complex32_t *A, int LDA),
          (uplo, M, N, alpha, beta, A, LDA) )
FUNCTION_VOID( CORE_claswp, LASWP, void ,
          (int N, PLASMA_Complex32_t *A, int LDA, int I1, int I2, const int *IPIV, int INC),
          (N, A, LDA, I1, I2, IPIV, INC) )
FUNCTION_TYPE( CORE_claswp_ontile, LASWP, int ,
          (PLASMA_desc descA, int i1, int i2, const int *ipiv, int inc),
          (descA, i1, i2, ipiv, inc) )
FUNCTION_TYPE( CORE_cswptr_ontile, TRSM, int ,
          (PLASMA_desc descA, int i1, int i2, const int *ipiv, int inc, const PLASMA_Complex32_t *Akk, int ldak),
          (descA, i1, i2, ipiv, inc, Akk, ldak) )
FUNCTION_TYPE( CORE_claswpc_ontile, LASWP, int ,
          (PLASMA_desc descA, int i1, int i2, const int *ipiv, int inc),
          (descA, i1, i2, ipiv, inc) )
FUNCTION_TYPE( CORE_clatro, LATRO, int ,
          (PLASMA_enum uplo, PLASMA_enum trans, int M, int N, const PLASMA_Complex32_t *A, int LDA, PLASMA_Complex32_t *B, int LDB),
          (uplo, trans, M, N, A, LDA, B, LDB) )
FUNCTION_VOID( CORE_clauum, LAUUM, void ,
          (PLASMA_enum uplo, int N, PLASMA_Complex32_t *A, int LDA),
          (uplo, N, A, LDA) )
FUNCTION_TYPE( CORE_cpemv, PEMV, int ,
          (PLASMA_enum trans, int storev, int M, int N, int L, PLASMA_Complex32_t ALPHA, const PLASMA_Complex32_t *A, int LDA, const PLASMA_Complex32_t *X, int INCX, PLASMA_Complex32_t BETA, PLASMA_Complex32_t *Y, int INCY, PLASMA_Complex32_t *WORK),
          (trans, storev, M, N, L, ALPHA, A, LDA, X, INCX, BETA, Y, INCY, WORK) )
#ifdef COMPLEX
FUNCTION_VOID( CORE_cplghe, PLGHE, void ,
          ( float bump, int m, int n, PLASMA_Complex32_t *A, int lda, int gM, int m0, int n0, unsigned long long int seed ),
          (bump, m, n, A, lda, gM, m0, n0, seed) )
#endif
FUNCTION_VOID( CORE_cplgsy, PLGSY, void ,
          ( PLASMA_Complex32_t bump, int m, int n, PLASMA_Complex32_t *A, int lda, int gM, int m0, int n0, unsigned long long int seed ),
          (bump, m, n, A, lda, gM, m0, n0, seed) )
FUNCTION_VOID( CORE_cplrnt, PLRNT, void ,
          ( int m, int n, PLASMA_Complex32_t *A, int lda, int gM, int m0, int n0, unsigned long long int seed ),
          (m, n, A, lda, gM, m0, n0, seed) )
FUNCTION_TYPE( CORE_cpltmg, PLRNT, int ,
          ( PLASMA_enum mtxtype, int M, int N, PLASMA_Complex32_t *A, int LDA, int gM, int gN, int m0, int n0, unsigned long long int seed ),
          (mtxtype, M, N, A, LDA, gM, gN, m0, n0, seed) )
FUNCTION_TYPE( CORE_cpltmg_chebvand, PLRNT, int ,
          ( int M, int N, PLASMA_Complex32_t *A, int LDA, int gN, int m0, int n0, PLASMA_Complex32_t *W ),
          (M, N, A, LDA, gN, m0, n0, W) )
FUNCTION_TYPE( CORE_cpltmg_circul, PLRNT, int ,
          ( int M, int N, PLASMA_Complex32_t *A, int LDA, int gM, int m0, int n0, const PLASMA_Complex32_t *V ),
          (M, N, A, LDA, gM, m0, n0, V) )
FUNCTION_VOID( CORE_cpltmg_condexq, PLRNT, void ,
          ( int M, int N, PLASMA_Complex32_t *Q, int LDQ ),
          (M, N, Q, LDQ) )
FUNCTION_VOID( CORE_cpltmg_fiedler, PLRNT, void ,
          ( int M, int N, const PLASMA_Complex32_t *X, int incX, const PLASMA_Complex32_t *Y, int incY, PLASMA_Complex32_t *A, int LDA ),
          (M, N, X, incX, Y, incY, A, LDA) )
FUNCTION_TYPE( CORE_cpltmg_hankel, PLRNT, int ,
          ( PLASMA_enum uplo, int M, int N, PLASMA_Complex32_t *A, int LDA, int m0, int n0, int nb, const PLASMA_Complex32_t *V1, const PLASMA_Complex32_t *V2 ),
          (uplo, M, N, A, LDA, m0, n0, nb, V1, V2) )
FUNCTION_VOID( CORE_cpltmg_toeppd1, PLRNT, void ,
          ( int gM, int m0, int M, PLASMA_Complex32_t *W, unsigned long long int seed ),
          (gM, m0, M, W, seed) )
FUNCTION_VOID( CORE_cpltmg_toeppd2, PLRNT, void ,
          ( int M, int N, int K, int m0, int n0, const PLASMA_Complex32_t *W, PLASMA_Complex32_t *A, int LDA ),
          (M, N, K, m0, n0, W, A, LDA) )
FUNCTION_VOID( CORE_cpotrf, POTRF, void ,
          (PLASMA_enum uplo, int N, PLASMA_Complex32_t *A, int LDA, int *info),
          (uplo, N, A, LDA, info) )
FUNCTION_VOID( CORE_csetvar, SETVAR, void ,
          (const PLASMA_Complex32_t *alpha, PLASMA_Complex32_t *x),
          (alpha, x) )
FUNCTION_VOID( CORE_cshiftw, SHIFTW, void ,
          (int s, int cl, int m, int n, int L, PLASMA_Complex32_t *A, PLASMA_Complex32_t *W) ,
          (s, cl, m, n, L, A, W)  )
FUNCTION_VOID( CORE_cshift, SHIFT, void ,
          (int s, int m, int n, int L, PLASMA_Complex32_t *A) ,
          (s, m, n, L, A)  )
FUNCTION_TYPE( CORE_cssssm, SSSSM, int ,
          (int M1, int N1, int M2, int N2, int K, int IB, PLASMA_Complex32_t *A1, int LDA1, PLASMA_Complex32_t *A2, int LDA2, const PLASMA_Complex32_t *L1, int LDL1, const PLASMA_Complex32_t *L2, int LDL2, const int *IPIV),
          (M1, N1, M2, N2, K, IB, A1, LDA1, A2, LDA2, L1, LDL1, L2, LDL2, IPIV) )
#ifdef COMPLEX
FUNCTION_TYPE( CORE_cstedc, STEDC, int ,
          ( PLASMA_enum compz, int n, float *D, float *E, PLASMA_Complex32_t *Z, int LDZ, PLASMA_Complex32_t *WORK, int LWORK, float *RWORK, int LRWORK, int *IWORK, int LIWORK ),
          (compz, n, D, E, Z, LDZ, WORK, LWORK, RWORK, LRWORK, IWORK, LIWORK) )
#else
FUNCTION_TYPE( CORE_cstedc, STEDC, int ,
          ( PLASMA_enum compz, int n, float *D, float *E, PLASMA_Complex32_t *Z, int LDZ, PLASMA_Complex32_t *WORK, int LWORK, int *IWORK, int LIWORK ),
          (compz, n, D, E, Z, LDZ, WORK, LWORK, IWORK, LIWORK) )
#endif
FUNCTION_TYPE( CORE_csteqr, STEQR, int ,
          ( PLASMA_enum compz, int n, float *D, float *E, PLASMA_Complex32_t *Z, int LDZ, float *WORK ),
          (compz, n, D, E, Z, LDZ, WORK) )
FUNCTION_VOID( CORE_cswap, SWAP, void ,
          (int m, int n, PLASMA_Complex32_t *Q, int ldq, const PLASMA_Complex32_t *work, const int *perm, int start, int end),
          (m, n, Q, ldq, work, perm, start, end) )
FUNCTION_VOID( CORE_cswpab, SWPAB, void ,
          (int i, int n1, int n2, PLASMA_Complex32_t *A, PLASMA_Complex32_t *work) ,
          (i, n1, n2, A, work)  )
FUNCTION_VOID( CORE_csymm, SYMM, void ,
          (PLASMA_enum side, PLASMA_enum uplo, int M, int N, PLASMA_Complex32_t alpha, const PLASMA_Complex32_t *A, int LDA, const PLASMA_Complex32_t *B, int LDB, PLASMA_Complex32_t beta, PLASMA_Complex32_t *C, int LDC),
          (side, uplo, M, N, alpha, A, LDA, B, LDB, beta, C, LDC) )
FUNCTION_VOID( CORE_csyr2k, SYR2K, void ,
          (PLASMA_enum uplo, PLASMA_enum trans, int N, int K, PLASMA_Complex32_t alpha, const PLASMA_Complex32_t *A, int LDA, const PLASMA_Complex32_t *B, int LDB, PLASMA_Complex32_t beta, PLASMA_Complex32_t *C, int LDC),
          (uplo, trans, N, K, alpha, A, LDA, B, LDB, beta, C, LDC) )
FUNCTION_VOID( CORE_csyrk, SYRK, void ,
          (PLASMA_enum uplo, PLASMA_enum trans, int N, int K, PLASMA_Complex32_t alpha, const PLASMA_Complex32_t *A, int LDA, PLASMA_Complex32_t beta, PLASMA_Complex32_t *C, int LDC),
          (uplo, trans, N, K, alpha, A, LDA, beta, C, LDC) )
FUNCTION_TYPE( CORE_csyssq, LASSQ, int ,
          (PLASMA_enum uplo, int N, const PLASMA_Complex32_t *A, int LDA, float *scale, float *sumsq),
          (uplo, N, A, LDA, scale, sumsq) )
FUNCTION_TYPE( CORE_ctradd, GEADD, int ,
          (PLASMA_enum uplo, PLASMA_enum trans, int M, int N, PLASMA_Complex32_t alpha, const PLASMA_Complex32_t *A, int LDA, PLASMA_Complex32_t beta, PLASMA_Complex32_t *B, int LDB),
          (uplo, trans, M, N, alpha, A, LDA, beta, B, LDB) )
FUNCTION_VOID( CORE_ctrasm, ASUM, void ,
          (PLASMA_enum storev, PLASMA_enum uplo, PLASMA_enum diag, int M, int N, const PLASMA_Complex32_t *A, int lda, float *work),
          (storev, uplo, diag, M, N, A, lda, work) )
FUNCTION_VOID( CORE_ctrdalg1, TRDALG, void ,
          ( int n, int nb, PLASMA_Complex32_t *A, int lda, PLASMA_Complex32_t *V, PLASMA_Complex32_t *TAU, int Vblksiz, int wantz, int i, int sweepid, int m, int grsiz, PLASMA_Complex32_t *work),
          (n, nb, A, lda, V, TAU, Vblksiz, wantz, i, sweepid, m, grsiz, work) )
FUNCTION_VOID( CORE_ctrmm, TRMM, void ,
          (PLASMA_enum side, PLASMA_enum uplo, PLASMA_enum transA, PLASMA_enum diag, int M, int N, PLASMA_Complex32_t alpha, const PLASMA_Complex32_t *A, int LDA, PLASMA_Complex32_t *B, int LDB),
          (side, uplo, transA, diag, M, N, alpha, A, LDA, B, LDB) )
FUNCTION_VOID( CORE_ctrsm, TRSM, void ,
          (PLASMA_enum side, PLASMA_enum uplo, PLASMA_enum transA, PLASMA_enum diag, int M, int N, PLASMA_Complex32_t alpha, const PLASMA_Complex32_t *A, int LDA, PLASMA_Complex32_t *B, int LDB),
          (side, uplo, transA, diag, M, N, alpha, A, LDA, B, LDB) )
FUNCTION_TYPE( CORE_ctrssq, LASSQ, int ,
          (PLASMA_enum uplo, PLASMA_enum diag, int M, int N, const PLASMA_Complex32_t *A, int LDA, float *scale, float *sumsq),
          (uplo, diag, M, N, A, LDA, scale, sumsq) )
FUNCTION_VOID( CORE_ctrtri, TRTRI, void ,
          (PLASMA_enum uplo, PLASMA_enum diag, int N, PLASMA_Complex32_t *A, int LDA, int *info),
          (uplo, diag, N, A, LDA, info) )
FUNCTION_TYPE( CORE_ctslqt, TSLQT, int ,
          (int M, int N, int IB, PLASMA_Complex32_t *A1, int LDA1, PLASMA_Complex32_t *A2, int LDA2, PLASMA_Complex32_t *T, int LDT, PLASMA_Complex32_t *TAU, PLASMA_Complex32_t *WORK),
          (M, N, IB, A1, LDA1, A2, LDA2, T, LDT, TAU, WORK) )
FUNCTION_TYPE( CORE_ctsmlq, TSMLQ, int ,
          (PLASMA_enum side, PLASMA_enum trans, int M1, int N1, int M2, int N2, int K, int IB, PLASMA_Complex32_t *A1, int LDA1, PLASMA_Complex32_t *A2, int LDA2, const PLASMA_Complex32_t *V, int LDV, const PLASMA_Complex32_t *T, int LDT, PLASMA_Complex32_t *WORK, int LDWORK),
          (side, trans, M1, N1, M2, N2, K, IB, A1, LDA1, A2, LDA2, V, LDV, T, LDT, WORK, LDWORK) )
FUNCTION_TYPE( CORE_ctsmlq_corner, TSMLQ, int ,
          ( int m1, int n1, int m2, int n2, int m3, int n3, int k, int ib, int nb, PLASMA_Complex32_t *A1, int lda1, PLASMA_Complex32_t *A2, int lda2, PLASMA_Complex32_t *A3, int lda3, const PLASMA_Complex32_t *V, int ldv, const PLASMA_Complex32_t *T, int ldt, PLASMA_Complex32_t *WORK, int ldwork),
          (m1, n1, m2, n2, m3, n3, k, ib, nb, A1, lda1, A2, lda2, A3, lda3, V, ldv, T, ldt, WORK, ldwork) )
FUNCTION_TYPE( CORE_ctsmlq_hetra1, TSMLQ, int ,
          ( PLASMA_enum side, PLASMA_enum trans, int m1, int n1, int m2, int n2, int k, int ib, PLASMA_Complex32_t *A1, int lda1, PLASMA_Complex32_t *A2, int lda2, const PLASMA_Complex32_t *V, int ldv, const PLASMA_Complex32_t *T, int ldt, PLASMA_Complex32_t *WORK, int ldwork),
          (side, trans, m1, n1, m2, n2, k, ib, A1, lda1, A2, lda2, V, ldv, T, ldt, WORK, ldwork) )
FUNCTION_TYPE( CORE_ctsmqr, TSMQR, int ,
          (PLASMA_enum side, PLASMA_enum trans, int M1, int N1, int M2, int N2, int K, int IB, PLASMA_Complex32_t *A1, int LDA1, PLASMA_Complex32_t *A2, int LDA2, const PLASMA_Complex32_t *V, int LDV, const PLASMA_Complex32_t *T, int LDT, PLASMA_Complex32_t *WORK, int LDWORK),
          (side, trans, M1, N1, M2, N2, K, IB, A1, LDA1, A2, LDA2, V, LDV, T, LDT, WORK, LDWORK) )
FUNCTION_TYPE( CORE_ctsmqr_corner, TSMQR, int ,
          ( int m1, int n1, int m2, int n2, int m3, int n3, int k, int ib, int nb, PLASMA_Complex32_t *A1, int lda1, PLASMA_Complex32_t *A2, int lda2, PLASMA_Complex32_t *A3, int lda3, const PLASMA_Complex32_t *V, int ldv, const PLASMA_Complex32_t *T, int ldt, PLASMA_Complex32_t *WORK, int ldwork),
          (m1, n1, m2, n2, m3, n3, k, ib, nb, A1, lda1, A2, lda2, A3, lda3, V, ldv, T, ldt, WORK, ldwork) )
FUNCTION_TYPE( CORE_ctsmqr_hetra1, TSMQR, int ,
          ( PLASMA_enum side, PLASMA_enum trans, int m1, int n1, int m2, int n2, int k, int ib, PLASMA_Complex32_t *A1, int lda1, PLASMA_Complex32_t *A2, int lda2, const PLASMA_Complex32_t *V, int ldv, const PLASMA_Complex32_t *T, int ldt, PLASMA_Complex32_t *WORK, int ldwork),
          (side, trans, m1, n1, m2, n2, k, ib, A1, lda1, A2, lda2, V, ldv, T, ldt, WORK, ldwork) )
FUNCTION_TYPE( CORE_ctsqrt, TSQRT, int ,
          (int M, int N, int IB, PLASMA_Complex32_t *A1, int LDA1, PLASMA_Complex32_t *A2, int LDA2, PLASMA_Complex32_t *T, int LDT, PLASMA_Complex32_t *TAU, PLASMA_Complex32_t *WORK),
          (M, N, IB, A1, LDA1, A2, LDA2, T, LDT, TAU, WORK) )
FUNCTION_TYPE( CORE_ctstrf, TSTRF, int ,
          (int M, int N, int IB, int NB, PLASMA_Complex32_t *U, int LDU, PLASMA_Complex32_t *A, int LDA, PLASMA_Complex32_t *L, int LDL, int *IPIV, PLASMA_Complex32_t *WORK, int LDWORK, int *INFO),
          (M, N, IB, NB, U, LDU, A, LDA, L, LDL, IPIV, WORK, LDWORK, INFO) )
FUNCTION_TYPE( CORE_cttlqt, TTLQT, int ,
          (int M, int N, int IB, PLASMA_Complex32_t *A1, int LDA1, PLASMA_Complex32_t *A2, int LDA2, PLASMA_Complex32_t *T, int LDT, PLASMA_Complex32_t *TAU, PLASMA_Complex32_t *WORK),
          (M, N, IB, A1, LDA1, A2, LDA2, T, LDT, TAU, WORK) )
FUNCTION_TYPE( CORE_cttmlq, TTMLQ, int ,
          (PLASMA_enum side, PLASMA_enum trans, int M1, int N1, int M2, int N2, int K, int IB, PLASMA_Complex32_t *A1, int LDA1, PLASMA_Complex32_t *A2, int LDA2, const PLASMA_Complex32_t *V, int LDV, const PLASMA_Complex32_t *T, int LDT, PLASMA_Complex32_t *WORK, int LDWORK),
          (side, trans, M1, N1, M2, N2, K, IB, A1, LDA1, A2, LDA2, V, LDV, T, LDT, WORK, LDWORK) )
FUNCTION_TYPE( CORE_cttmqr, TTMQR, int ,
          (PLASMA_enum side, PLASMA_enum trans, int M1, int N1, int M2, int N2, int K, int IB, PLASMA_Complex32_t *A1, int LDA1, PLASMA_Complex32_t *A2, int LDA2, const PLASMA_Complex32_t *V, int LDV, const PLASMA_Complex32_t *T, int LDT, PLASMA_Complex32_t *WORK, int LDWORK),
          (side, trans, M1, N1, M2, N2, K, IB, A1, LDA1, A2, LDA2, V, LDV, T, LDT, WORK, LDWORK) )
FUNCTION_TYPE( CORE_cttqrt, TTQRT, int ,
          (int M, int N, int IB, PLASMA_Complex32_t *A1, int LDA1, PLASMA_Complex32_t *A2, int LDA2, PLASMA_Complex32_t *T, int LDT, PLASMA_Complex32_t *TAU, PLASMA_Complex32_t *WORK),
          (M, N, IB, A1, LDA1, A2, LDA2, T, LDT, TAU, WORK) )
FUNCTION_TYPE( CORE_cunmlq, UNMLQ, int ,
          (PLASMA_enum side, PLASMA_enum trans, int M, int N, int K, int IB, const PLASMA_Complex32_t *A, int LDA, const PLASMA_Complex32_t *T, int LDT, PLASMA_Complex32_t *C, int LDC, PLASMA_Complex32_t *WORK, int LDWORK),
          (side, trans, M, N, K, IB, A, LDA, T, LDT, C, LDC, WORK, LDWORK) )
FUNCTION_TYPE( CORE_cunmqr, UNMQR, int ,
          (PLASMA_enum side, PLASMA_enum trans, int M, int N, int K, int IB, const PLASMA_Complex32_t *A, int LDA, const PLASMA_Complex32_t *T, int LDT, PLASMA_Complex32_t *C, int LDC, PLASMA_Complex32_t *WORK, int LDWORK),
          (side, trans, M, N, K, IB, A, LDA, T, LDT, C, LDC, WORK, LDWORK) )

